

#include "CNode.h"


//constructor
CNode::CNode()
{
	//make sure node pointers point to nothing
	literal = NULL;
	match = NULL;
	repeat = NULL;
}


//destructor
CNode::~CNode()
{
	//delete literal node if necessary
	if (literal)
		delete literal;

	//delete match node if necessary
	if (match)
		delete match;

	//delete repeat node if necessary
	if (repeat)
		delete repeat;
}


//initialise node
void CNode::Init(CNode *parent, int type, int cost, int position)
{
	//initialise variables in node
	this->parent = parent;
	this->type = type;
	this->cost = cost;
	this->position = position;
}


//set literal value
void CNode::InitLiteral(unsigned char literal)
{
	lit = literal;
}


//set match offset and length
void CNode::InitMatch(int offset, int length)
{
	this->offset = offset;
	this->length = length;
}


//set repeat length
void CNode::InitRepeat(int length)
{
	this->length = length;
}


//get literal value
unsigned char CNode::GetLiteralValue()
{
	return lit;
}


//get match offset
int CNode::GetMatchOffset()
{
	return offset;
}


//get match length
int CNode::GetMatchLength()
{
	return length;
}


//get repeat length
int CNode::GetRepeatLength()
{
	return length;
}


//set literal node
void CNode::SetLiteral(CNode *literal)
{
	this->literal = literal;
}


//set match node
void CNode::SetMatch(CNode *match)
{
	this->match = match;
}


//set repeat node
void CNode::SetRepeat(CNode *repeat)
{
	this->repeat = repeat;
}


//get node type
int CNode::GetType()
{
	return type;
}


//get cost until this node
int CNode::GetCost()
{
	return cost;
}


//get position till this node
int CNode::GetPosition()
{
	return position;
}


//get parent of node
CNode* CNode::GetParent()
{
	return parent;
}


//get literal node
CNode* CNode::GetLiteral()
{
	return literal;
}


//get match node
CNode* CNode::GetMatch()
{
	return match;
}


//get repeat node
CNode* CNode::GetRepeat()
{
	return repeat;
}

