

#ifndef CNODE_H
#define CNODE_H


#define	NODE_TYPE_TOP		1
#define	NODE_TYPE_LITERAL	2
#define NODE_TYPE_MATCH		3
#define	NODE_TYPE_REPEAT	4
#define NODE_TYPE_OPTIMAL	5


#ifndef NULL
#define NULL 0
#endif


class CNode;


class CNode
{
private:
	int type;		//node type
	int cost;		//cost in number of bits to get here
	int position;	//number of bytes encoded

	unsigned char lit;	//literal value
	int offset;
	int length;

	CNode *parent;	//pointer to parent node
	CNode *literal;	//pointer to next literal node
	CNode *match;	//pointer to next match node
	CNode *repeat;	//pointer to next repeat node
public:
	CNode();
	~CNode();

	void Init(CNode *parent, int type, int cost, int position);	//initialise node

	void InitLiteral(unsigned char literal);
	void InitMatch(int offset, int length);
	void InitRepeat(int length);

	unsigned char GetLiteralValue();
	int GetMatchOffset();
	int GetMatchLength();
	int GetRepeatLength();

	void SetLiteral(CNode *literal);
	void SetMatch(CNode *match);
	void SetRepeat(CNode *repeat);

	int GetType();
	int GetCost();
	int GetPosition();
	CNode* GetParent();
	CNode* GetLiteral();
	CNode* GetMatch();
	CNode* GetRepeat();
};








#endif
